/*----------------------------*/
/*---------O[o---------*/
/*----------------------------*/
float4x4 mW;
float4x4 mWVP;
float4 Diffuse;
float4 Ambient;		// F
float4 Specular;	// ːF
float Power;		// ːF̗
float3 LightDir;
float3 CamPos;		// _̈ʒu
texture MeshTex;
texture ToonTex;	//AeeNX`
float InkSize = 0.025;	//֊sTCY
float4 InkColor = float4(0,0,0,1);	//֊sF

// XLbVŎgp
static const int MAX_MATRICES = 26;
float4x3 mWorldMatrixArray[MAX_MATRICES];	// [hsz
float4x4 mVP : VIEWPROJECTION;				// r[ˉe
int CurNumBones = 2;

//MeshTexpTv
sampler MeshSmp = sampler_state{
	Texture = <MeshTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};
//ToonTexpTv
sampler ToonSmp = sampler_state{
	Texture = <ToonTex>;
	MipFilter = LINEAR;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	AddressU = Clamp;
};
//gD[o̓f[^
struct VS_OUTPUT{
	float4 Pos : POSITION;
	float4 Col		: COLOR0;
	float4 Spe		: COLOR1;
	float2 MeshUV : TEXCOORD0;
	float2 ToonUV : TEXCOORD1;
};
//֊spo̓f[^
struct INKVS_OUTPUT{
	float4 Pos : POSITION;
};

/*------------------------------*/
/*------_VF[_(Œ)------*/
/*------------------------------*/
//gD[_VF[_
VS_OUTPUT VS(float4 pos : POSITION,float3 normal : NORMAL,float4 W : BLENDWEIGHT,float2 mesh_uv : TEXCOORD0){
	VS_OUTPUT Out = (VS_OUTPUT)0;
	Out.Pos = mul(pos,mWVP);
	Out.MeshUV = mesh_uv;
	
	// _F
	float3 w_normal=normalize(mul(normal, (float3x3)mW));	// [hnɕϊ
	Out.Col = Ambient + Diffuse*max(0, dot(-LightDir,w_normal));
	Out.Col.a = Diffuse.a;

	// XyL
	float3 vEye = normalize( CamPos - mul( pos, mW ) );		// (J)ւ̕
	float3 vRef = LightDir + 2.0f * dot( w_normal, -LightDir ) * w_normal;
	Out.Spe = Specular * pow(max(0,dot(vEye,vRef)),Power);
	
	float pw = max(0,dot(-LightDir,w_normal));
	Out.ToonUV.x=pw;
	Out.ToonUV.y=0;
	return Out;
}
//֊s_VF[_
INKVS_OUTPUT InkVS(float4 pos : POSITION,float3 normal : NORMAL,float4 W : BLENDWEIGHT){
	INKVS_OUTPUT Out = (INKVS_OUTPUT)0;
	float4 wvp_pos = mul(pos,mWVP);
	float4 wvp_normal = normalize(mul(normal,mWVP));
	Out.Pos = wvp_pos + wvp_normal * InkSize;

	return Out;
}

/*------------------------------*/
/*-----_VF[_(XL)-----*/
/*------------------------------*/
//gD[_VF[_
VS_OUTPUT SkinVS(float4 pos : POSITION,float4 BlendWeights : BLENDWEIGHT,float4 BlendIndices : BLENDINDICES,float3 normal : NORMAL,float2 mesh_uv : TEXCOORD0,uniform int NumBones){
	VS_OUTPUT Out = (VS_OUTPUT)0;
//	Out.Pos = mul(pos,mWVP);
//	float3 w_normal=normalize(mul(normal,(float3x3)mW));

	float3      Pos = 0.0f;
	float3      Normal = 0.0f;    
	float       LastWeight = 0.0f;
	// Compensate for lack of UBYTE4 on Geforce3
	int4 IndexVector = D3DCOLORtoUBYTE4(BlendIndices);
	// zɓ
	float BlendWeightsArray[4] = (float[4])BlendWeights;
	int   IndexArray[4]        = (int[4])IndexVector;
	// d݂gpčWƖ@vZAd݂~ςĂB
	for (int iBone = 0; iBone < NumBones-1; iBone++)
	{
		LastWeight = LastWeight + BlendWeightsArray[iBone];

		Pos += mul(pos, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
		Normal += mul(normal, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
	}
	LastWeight = 1.0f - LastWeight;
	// ŏIIȉe
	Pos += (mul(pos, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
	Normal += (mul(normal, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
	// r[sƎˉesŕϊ2DW
	Out.Pos = mul(float4(Pos.xyz, 1.0f), mVP);
	// @K
	Normal = normalize(Normal);
	
	Out.MeshUV = mesh_uv;
	// CeBO
	Out.Col = Ambient + Diffuse*max(0, dot(-LightDir,Normal));
	Out.Col.a = Diffuse.a;

	// XyL
	float3 vEye = normalize( CamPos - Pos );		// (J)ւ̕
	float3 vRef = LightDir + 2.0f * dot( Normal, -LightDir ) * Normal;
	Out.Spe = Specular * pow(max(0,dot(vEye,vRef)),Power);
	
	float pw = max(0,dot(-LightDir,Normal));
	Out.ToonUV.x=pw;
	Out.ToonUV.y=0;
	return Out;
}
//֊s_VF[_
INKVS_OUTPUT SkinInkVS(float4 pos : POSITION,float4 BlendWeights : BLENDWEIGHT,float4 BlendIndices : BLENDINDICES,float3 normal : NORMAL,uniform int NumBones){
	INKVS_OUTPUT Out = (INKVS_OUTPUT)0;
//	float4 wvp_pos = mul(pos,mWVP);
//	float4 wvp_normal = normalize(mul(normal,mWVP));

	float3      Pos = 0.0f;
	float3      Normal = 0.0f;    
	float       LastWeight = 0.0f;
	// Compensate for lack of UBYTE4 on Geforce3
	int4 IndexVector = D3DCOLORtoUBYTE4(BlendIndices);
	// zɓ
	float BlendWeightsArray[4] = (float[4])BlendWeights;
	int   IndexArray[4]        = (int[4])IndexVector;
	// d݂gpčWƖ@vZAd݂~ςĂB
	for (int iBone = 0; iBone < NumBones-1; iBone++)
	{
		LastWeight = LastWeight + BlendWeightsArray[iBone];

		Pos += mul(pos, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
		Normal += mul(normal, mWorldMatrixArray[IndexArray[iBone]]) * BlendWeightsArray[iBone];
	}
	LastWeight = 1.0f - LastWeight;
	// ŏIIȉe
	Pos += (mul(pos, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
	Normal += (mul(normal, mWorldMatrixArray[IndexArray[NumBones-1]]) * LastWeight);
	// r[sƎˉesŕϊ2DW
	Out.Pos = mul(float4(Pos.xyz, 1.0f), mVP);
	// @K
	Normal = normalize(Normal);
	
	float4 wvp_normal = normalize(mul(Normal,mVP));

	Out.Pos = Out.Pos + wvp_normal * InkSize;

	return Out;
}

/*------------------------------*/
/*-------sNZVF[_-------*/
/*------------------------------*/
//gD[sNZVF[_
float4 PS(VS_OUTPUT In):COLOR0{
//	return Diffuse*tex2D(MeshSmp,In.MeshUV)*tex2D(ToonSmp,In.ToonUV);
	return tex2D(MeshSmp, In.MeshUV) * tex2D(ToonSmp,In.ToonUV) * In.Col + In.Spe;
}
//֊ssNZVF[_
float4 InkPS(INKVS_OUTPUT In):COLOR0{
	return InkColor;
}

/*------------------------------*/
/*----------eNjbN----------*/
/*------------------------------*/

technique Toon{
	//pX0	gD[`
	pass P0{
		VertexShader = compile vs_2_0 VS();	//_VF[_
		PixelShader = compile ps_2_0 PS();	//sNZVF[_
		CullMode = CCW;	//\ʃ[h
	}
	//pX1	֊s`
	pass P1{
		VertexShader = compile vs_2_0 InkVS();	//_VF[_
		PixelShader = compile ps_2_0 InkPS();	//sNZVF[_
		CullMode = CW;	//ʃ[h
	}
}


//XL`
VertexShader SkinVSArray[4] = {compile vs_2_0 SkinVS(1),compile vs_2_0 SkinVS(2),compile vs_2_0 SkinVS(3),compile vs_2_0 SkinVS(4)};
VertexShader SkinInkVSArray[4] = {compile vs_2_0 SkinInkVS(1),compile vs_2_0 SkinInkVS(2),compile vs_2_0 SkinInkVS(3),compile vs_2_0 SkinInkVS(4)};

technique SkinToon{
	//pX0	gD[`
	pass P0{
        VertexShader = (SkinVSArray[CurNumBones]);
		PixelShader = compile ps_2_0 PS();	//sNZVF[_
		CullMode = CCW;	//\ʃ[h
	}
	//pX1	֊s`
	pass P1{
        VertexShader = (SkinInkVSArray[CurNumBones]);
		PixelShader = compile ps_2_0 InkPS();	//sNZVF[_
		CullMode = CW;	//ʃ[h
	}
}